diff --git a/kernel/netlink.c b/kernel/netlink.c
index e220d761b1f27aa31eab3ad1b9211ddfe55eaabd..a37da59335f8321e0f6529b4580a9ebdb9780d8e 100644
--- a/kernel/netlink.c
+++ b/kernel/netlink.c
@@ -578,20 +945,23 @@ static int wg_set_device(struct sk_buff *skb, struct genl_info *info)
 		}
 		up_write(&wg->static_identity.lock);
 	}
-skip_set_private_key:
 
+skip_set_private_key:
 	if (info->attrs[WGDEVICE_A_PEERS]) {
 		struct nlattr *attr, *peer[WGPEER_A_MAX + 1];
 		int rem;
 
 		nla_for_each_nested(attr, info->attrs[WGDEVICE_A_PEERS], rem) {
-			ret = nla_parse_nested(peer, WGPEER_A_MAX, attr,
-					       peer_policy, NULL);
-			if (ret < 0)
+			ret = nla_parse_nested(peer, WGPEER_A_MAX, attr, peer_policy, NULL);
+			if (ret < 0) {
+				wg_dbg("Error parsing nested peer attributes: %d\n", ret);
 				goto out;
+			}
 			ret = set_peer(wg, peer);
-			if (ret < 0)
+			if (ret < 0) {
+				wg_dbg("Error setting peer: %d\n", ret);
 				goto out;
+			}
 		}
 	}
 	ret = 0;
@@ -602,8 +972,10 @@ out:
 	dev_put(wg->dev);
 out_nodev:
 	if (info->attrs[WGDEVICE_A_PRIVATE_KEY])
-		memzero_explicit(nla_data(info->attrs[WGDEVICE_A_PRIVATE_KEY]),
-				 nla_len(info->attrs[WGDEVICE_A_PRIVATE_KEY]));
+		memzero_explicit(nla_data(info->attrs[WGDEVICE_A_PRIVATE_KEY]), nla_len(info->attrs[WGDEVICE_A_PRIVATE_KEY]));
+
+	wg_dbg("Exiting wg_set_device\n");
+
 	return ret;
 }
 
@@ -614,7 +986,8 @@ static const struct genl_ops genl_ops[] = {
 		.dumpit = wg_get_device_dump,
 		.done = wg_get_device_done,
 		.flags = GENL_UNS_ADMIN_PERM
-	}, {
+	},
+	{
 		.cmd = WG_CMD_SET_DEVICE,
 		.doit = wg_set_device,
 		.flags = GENL_UNS_ADMIN_PERM
@@ -635,10 +1008,20 @@ static struct genl_family genl_family __ro_after_init = {
 
 int __init wg_genetlink_init(void)
 {
-	return genl_register_family(&genl_family);
+	wg_dbg("Entering wg_genetlink_init\n");
+
+	int ret = genl_register_family(&genl_family);
+
+	wg_dbg("Exiting wg_genetlink_init\n");
+
+	return ret;
 }
 
 void __exit wg_genetlink_uninit(void)
 {
+	wg_dbg("Entering wg_genetlink_uninit\n");
+
 	genl_unregister_family(&genl_family);
+
+	wg_dbg("Exiting wg_genetlink_uninit\n");
 }
diff --git a/kernel/noise.c b/kernel/noise.c
index 202a33af5a721f2216ad0815e7b63a28d2bf5888..7b9972c39adf948c07ef2fb8e8db1a1b8b090110 100644
--- a/kernel/noise.c
+++ b/kernel/noise.c
@@ -641,6 +641,21 @@ wg_noise_handshake_consume_initiation(struct message_handshake_initiation *src,
 
 	/* Success! Copy everything to peer */
 	down_write(&handshake->lock);
+	/* Resolve simultaneous TCP initiation while the Noise state transition is
+	 * serialized. The lower static public key remains the initiator.
+	 */
+	if (wg->transport == WG_TRANSPORT_TCP) {
+		if (handshake->state == HANDSHAKE_CREATED_INITIATION) {
+			int cmp = memcmp(wg->static_identity.static_public,
+					 handshake->remote_static,
+					 NOISE_PUBLIC_KEY_LEN);
+
+			if (cmp < 0) {
+				up_write(&handshake->lock);
+				goto out;
+			}
+		}
+	}
 	memcpy(handshake->remote_ephemeral, e, NOISE_PUBLIC_KEY_LEN);
 	if (memcmp(t, handshake->latest_timestamp, NOISE_TIMESTAMP_LEN) > 0)
 		memcpy(handshake->latest_timestamp, t, NOISE_TIMESTAMP_LEN);
diff --git a/kernel/peer.c b/kernel/peer.c
index 1cb502a932e07c16ecf91121a294ccafc7005516..d48384eb5a5a92d18927116b305c9744e2619664 100644
--- a/kernel/peer.c
+++ b/kernel/peer.c
@@ -1,19 +1,24 @@
 // SPDX-License-Identifier: GPL-2.0
 /*
  * Copyright (C) 2015-2019 Jason A. Donenfeld <Jason@zx2c4.com>. All Rights Reserved.
+ * TCP Support Copyright (c) 2024-2026 Jeff Nathan and Dragos Ruiu. All Rights Reserved.
  */
 
-#include "peer.h"
 #include "device.h"
+#include "noise.h"
+#include "peer.h"
+#include "peerlookup.h"
 #include "queueing.h"
+#include "socket.h"
+#include "wg_tcp.h"
 #include "timers.h"
-#include "peerlookup.h"
-#include "noise.h"
+#include "wg_tcp_debug.h"
 
 #include <linux/kref.h>
 #include <linux/lockdep.h>
 #include <linux/rcupdate.h>
 #include <linux/list.h>
+#include <linux/wireguard.h>
 
 static struct kmem_cache *peer_cache;
 static atomic64_t peer_counter = ATOMIC64_INIT(0);
@@ -22,19 +27,25 @@ struct wg_peer *wg_peer_create(struct wg_device *wg,
 			       const u8 public_key[NOISE_PUBLIC_KEY_LEN],
 			       const u8 preshared_key[NOISE_SYMMETRIC_KEY_LEN])
 {
+	wg_dbg("wg_peer_create: entry with wg=%px, public_key=%px, preshared_key=%px\n", wg, public_key, preshared_key);
 	struct wg_peer *peer;
 	int ret = -ENOMEM;
 
 	lockdep_assert_held(&wg->device_update_lock);
 
-	if (wg->num_peers >= MAX_PEERS_PER_DEVICE)
+	if (wg->num_peers >= MAX_PEERS_PER_DEVICE) {
+		wg_dbg("wg_peer_create: exit with ERR_PTR(ret)\n");
 		return ERR_PTR(ret);
+	}
 
 	peer = kmem_cache_zalloc(peer_cache, GFP_KERNEL);
-	if (unlikely(!peer))
+	if (unlikely(!peer)) {
+		wg_dbg("wg_peer_create: exit with ERR_PTR(ret)\n");
 		return ERR_PTR(ret);
-	if (unlikely(dst_cache_init(&peer->endpoint_cache, GFP_KERNEL)))
-		goto err;
+	}
+	if (unlikely(dst_cache_init(&peer->endpoint_cache, GFP_KERNEL))) {
+		goto err_free_peer;
+	}
 
 	peer->device = wg;
 	wg_noise_handshake_init(&peer->handshake, &wg->static_identity,
@@ -53,32 +64,127 @@ struct wg_peer *wg_peer_create(struct wg_device *wg,
 	kref_init(&peer->refcount);
 	skb_queue_head_init(&peer->staged_packet_queue);
 	wg_noise_reset_last_sent_handshake(&peer->last_sent_handshake);
+	/* TCP field initialization */
+	peer->peer_socket = NULL; /* Initialize the peer socket to NULL */
+
+	peer->partial_skb = NULL; /* Initialize the partial skb pointer to NULL */
+	peer->expected_len = 0; /* Initialize expected length to 0 */
+	peer->received_len = 0; /* Initialize received length to 0 */
+
+	/* Initialize the TCP retry scheduled flag to false */
+	peer->tcp_retry_scheduled = false;
+
+	/* Initialize the delayed work for TCP connection retry */
+	INIT_DELAYED_WORK(&peer->tcp_retry_work, wg_tcp_retry_worker);
+
+	/* Initialize the delayed work for TCP socket removal */
+	INIT_DELAYED_WORK(&peer->tcp_inbound_remove_work, wg_tcp_inbound_remove_worker);
+	INIT_DELAYED_WORK(&peer->tcp_outbound_remove_work, wg_tcp_outbound_remove_worker);
+
+	/* Initialize TCP connection status flags */
+	peer->tcp_established = false;
+	peer->tcp_pending = false;
+	peer->tcp_connecting = false;
+	peer->tcp_inbound_callbacks_set = false;
+	peer->tcp_outbound_callbacks_set = false;
+	peer->tcp_inbound_socket_data = NULL;
+	peer->tcp_outbound_socket_data = NULL;
+	peer->tcp_outbound_remove_scheduled = false;
+	peer->tcp_reconnect_requested = false;
+	peer->tcp_stopping = false;
+	peer->tcp_teardown_quarantined = false;
+	peer->tcp_outbound_remove_socket = NULL;
+	peer->tcp_inbound_remove_socket = NULL;
+	peer->tcp_roaming_connection_id = 0;
+	peer->tcp_inbound_remove_scheduled = false;
+	peer->peer_endpoint_set = false;
+
+	/* Initialize the spinlock for protecting TCP-related state */
+	mutex_init(&peer->tcp_socket_lock);
+	spin_lock_init(&peer->tcp_lock);
+	spin_lock_init(&peer->tcp_read_lock);
+	spin_lock_init(&peer->tcp_write_lock);
+
+	/* Initialize the skb queue for the TX send queue */
+	skb_queue_head_init(&peer->send_queue);
+
+	/* Initialize the spinlock for the TX send queue */
+	spin_lock_init(&peer->send_queue_lock);
+
+	/* Initialize the list head for pending connection list */
+	INIT_LIST_HEAD(&peer->pending_connection_list);
+
+	/* Initialize the work structure, associating it with the worker functions */
+	INIT_WORK(&peer->tcp_read_work, wg_tcp_read_worker);
+	INIT_WORK(&peer->tcp_write_work, wg_tcp_write_worker);
+	INIT_WORK(&peer->tcp_bootstrap_work, wg_tcp_bootstrap_worker);
+	peer->tcp_bootstrap_socket = NULL;
+	INIT_WORK(&peer->tcp_promotion_work, wg_tcp_promotion_worker);
+	peer->tcp_promotion_connection_id = 0;
+	peer->tcp_promotion_worker_scheduled = false;
+	if (wg->transport == WG_TRANSPORT_TCP) {
+		peer->tcp_read_wq = alloc_workqueue("tcp_read_wq",
+						    WQ_UNBOUND | WQ_MEM_RECLAIM, 0);
+		if (!peer->tcp_read_wq) {
+			pr_err("Failed to allocate read workqueue\n");
+			goto err_destroy_endpoint_cache;
+		}
+
+		peer->tcp_write_wq = alloc_workqueue("tcp_write_wq",
+						     WQ_UNBOUND | WQ_MEM_RECLAIM, 0);
+		if (!peer->tcp_write_wq) {
+			pr_err("Failed to allocate write workqueue\n");
+			goto err_destroy_tcp_read_wq;
+		}
+	}
+
+	/* Indicate this is a real peer not a temp peer */
+	peer->temp_peer = false;
+	peer->peer_endpoint = peer->endpoint;
+
 	set_bit(NAPI_STATE_NO_BUSY_POLL, &peer->napi.state);
 	netif_napi_add(wg->dev, &peer->napi, wg_packet_rx_poll);
 	napi_enable(&peer->napi);
 	list_add_tail(&peer->peer_list, &wg->peer_list);
 	INIT_LIST_HEAD(&peer->allowedips_list);
 	wg_pubkey_hashtable_add(wg->peer_hashtable, peer);
+
 	++wg->num_peers;
 	pr_debug("%s: Peer %llu created\n", wg->dev->name, peer->internal_id);
+	wg_dbg("wg_peer_create: exit with peer=%px\n", peer);
 	return peer;
 
-err:
+err_destroy_tcp_read_wq:
+	destroy_workqueue(peer->tcp_read_wq);
+err_destroy_endpoint_cache:
+	dst_cache_destroy(&peer->endpoint_cache);
+err_free_peer:
 	kmem_cache_free(peer_cache, peer);
+	wg_dbg("wg_peer_create: exit with ERR_PTR(ret) on err\n");
 	return ERR_PTR(ret);
 }
 
 struct wg_peer *wg_peer_get_maybe_zero(struct wg_peer *peer)
 {
+	wg_dbg("wg_peer_get_maybe_zero: entry with peer=%px\n", peer);
 	RCU_LOCKDEP_WARN(!rcu_read_lock_bh_held(),
 			 "Taking peer reference without holding the RCU read lock");
-	if (unlikely(!peer || !kref_get_unless_zero(&peer->refcount)))
+	if (unlikely(!peer || !kref_get_unless_zero(&peer->refcount))) {
+		wg_dbg("wg_peer_get_maybe_zero: exit with NULL\n");
 		return NULL;
+	}
+	wg_dbg("wg_peer_get_maybe_zero: exit with peer=%px\n", peer);
 	return peer;
 }
 
 static void peer_make_dead(struct wg_peer *peer)
 {
+	wg_dbg("peer_make_dead: entry with peer=%px\n", peer);
+	if(!peer || IS_ERR(peer)){
+		wg_dbg("Exiting function peer_remove_after_dead, no peer.\n");
+		return;
+	}
+
 	/* Remove from configuration-time lookup structures. */
 	list_del_init(&peer->peer_list);
 	wg_allowedips_remove_by_peer(&peer->device->peer_allowedips, peer,
@@ -88,11 +194,57 @@ static void peer_make_dead(struct wg_peer *peer)
 	/* Mark as dead, so that we don't allow jumping contexts after. */
 	WRITE_ONCE(peer->is_dead, true);
 
+	/* Cancel any pending remove/retry delayed work (non-sync to avoid
+	 * self-deadlock if called from a remove worker context).
+	 */
+	cancel_delayed_work(&peer->tcp_outbound_remove_work);
+	peer->tcp_outbound_remove_scheduled = false;
+	peer->tcp_outbound_remove_socket = NULL;
+	peer->tcp_inbound_remove_socket = NULL;
+	peer->tcp_reconnect_requested = false;
+	peer->tcp_stopping = true;
+	cancel_delayed_work(&peer->tcp_inbound_remove_work);
+	peer->tcp_inbound_remove_scheduled = false;
+	cancel_delayed_work(&peer->tcp_retry_work);
+	peer->tcp_retry_scheduled = false;
+
+	/* Check if the TCP read work is scheduled before canceling it */
+	if (peer->tcp_read_worker_scheduled) {
+		cancel_work_sync(&peer->tcp_read_work);
+		peer->tcp_read_worker_scheduled = false;
+	}
+
+	/* Destroy the TCP read workqueue if it exists */
+	if (peer->tcp_read_wq) {
+		destroy_workqueue(peer->tcp_read_wq);
+		peer->tcp_read_wq = NULL; /* Avoid dangling pointers */
+	}
+
+	/* Check if the TCP write work is scheduled before canceling it */
+	if (peer->tcp_write_worker_scheduled) {
+		cancel_work_sync(&peer->tcp_write_work);
+		peer->tcp_write_worker_scheduled = false; /* Reset the flag after canceling */
+	}
+
+	/* Destroy the TCP write workqueue if it exists */
+	if (peer->tcp_write_wq) {
+		destroy_workqueue(peer->tcp_write_wq);
+		peer->tcp_write_wq = NULL; /* Avoid dangling pointers */
+	}
+
+	/* clean up any partial TCP data if it exists */
+	if (peer->partial_skb) {
+		kfree_skb(peer->partial_skb);
+		peer->partial_skb = NULL;
+	}
+
 	/* The caller must now synchronize_net() for this to take effect. */
+	wg_dbg("peer_make_dead: exit\n");
 }
 
 static void peer_remove_after_dead(struct wg_peer *peer)
 {
+	wg_dbg("peer_remove_after_dead: entry with peer=%px\n", peer);
 	WARN_ON(!peer->is_dead);
 
 	/* No more keypairs can be created for this peer, since is_dead protects
@@ -147,6 +299,7 @@ static void peer_remove_after_dead(struct wg_peer *peer)
 
 	--peer->device->num_peers;
 	wg_peer_put(peer);
+	wg_dbg("peer_remove_after_dead: exit\n");
 }
 
 /* We have a separate "remove" function make sure that all active places where
@@ -155,17 +308,25 @@ static void peer_remove_after_dead(struct wg_peer *peer)
  */
 void wg_peer_remove(struct wg_peer *peer)
 {
-	if (unlikely(!peer))
+	wg_dbg("wg_peer_remove: entry with peer=%px\n", peer);
+	if (unlikely(!peer)) {
+		wg_dbg("wg_peer_remove: exit (peer is NULL)\n");
 		return;
+	}
 	lockdep_assert_held(&peer->device->device_update_lock);
-
+	/* Claim both directions, detach callbacks, and quiesce stream workers
+	 * before either socket or its sk_user_data wrapper can be released.
+	 */
+	wg_tcp_peer_stop(peer);
 	peer_make_dead(peer);
 	synchronize_net();
 	peer_remove_after_dead(peer);
+	wg_dbg("wg_peer_remove: exit\n");
 }
 
 void wg_peer_remove_all(struct wg_device *wg)
 {
+	wg_dbg("wg_peer_remove_all: entry with wg=%px\n", wg);
 	struct wg_peer *peer, *temp;
 	LIST_HEAD(dead_peers);
 
@@ -174,6 +335,12 @@ void wg_peer_remove_all(struct wg_device *wg)
 	/* Avoid having to traverse individually for each one. */
 	wg_allowedips_free(&wg->peer_allowedips, &wg->device_update_lock);
 
+	/* First pass: claim and quiesce both TCP directions for every peer before
+	 * peer_make_dead destroys their workqueues.
+	 */
+	list_for_each_entry(peer, &wg->peer_list, peer_list)
+		wg_tcp_peer_stop(peer);
+
 	list_for_each_entry_safe(peer, temp, &wg->peer_list, peer_list) {
 		peer_make_dead(peer);
 		list_add_tail(&peer->peer_list, &dead_peers);
@@ -181,10 +348,12 @@ void wg_peer_remove_all(struct wg_device *wg)
 	synchronize_net();
 	list_for_each_entry_safe(peer, temp, &dead_peers, peer_list)
 		peer_remove_after_dead(peer);
+	wg_dbg("wg_peer_remove_all: exit\n");
 }
 
 static void rcu_release(struct rcu_head *rcu)
 {
+	wg_dbg("rcu_release: entry with rcu=%px\n", rcu);
 	struct wg_peer *peer = container_of(rcu, struct wg_peer, rcu);
 
 	dst_cache_destroy(&peer->endpoint_cache);
@@ -195,10 +364,12 @@ static void rcu_release(struct rcu_head *rcu)
 	 */
 	memzero_explicit(peer, sizeof(*peer));
 	kmem_cache_free(peer_cache, peer);
+	wg_dbg("rcu_release: exit\n");
 }
 
 static void kref_release(struct kref *refcount)
 {
+	wg_dbg("kref_release: entry with refcount=%px\n", refcount);
 	struct wg_peer *peer = container_of(refcount, struct wg_peer, refcount);
 
 	pr_debug("%s: Peer %llu (%pISpfsc) destroyed\n",
@@ -218,22 +389,31 @@ static void kref_release(struct kref *refcount)
 
 	/* Free the memory used. */
 	call_rcu(&peer->rcu, rcu_release);
+	wg_dbg("kref_release: exit\n");
 }
 
 void wg_peer_put(struct wg_peer *peer)
 {
-	if (unlikely(!peer))
+	wg_dbg("wg_peer_put: entry with peer=%px\n", peer);
+	if (unlikely(!peer)) {
+		wg_dbg("wg_peer_put: exit (peer is NULL)\n");
 		return;
+	}
 	kref_put(&peer->refcount, kref_release);
+	wg_dbg("wg_peer_put: exit\n");
 }
 
 int __init wg_peer_init(void)
 {
+	wg_dbg("wg_peer_init: entry\n");
 	peer_cache = KMEM_CACHE(wg_peer, 0);
+	wg_dbg("wg_peer_init: exit with %d\n", peer_cache ? 0 : -ENOMEM);
 	return peer_cache ? 0 : -ENOMEM;
 }
 
 void wg_peer_uninit(void)
 {
+	wg_dbg("wg_peer_uninit: entry\n");
 	kmem_cache_destroy(peer_cache);
+	wg_dbg("wg_peer_uninit: exit\n");
 }
diff --git a/kernel/peer.h b/kernel/peer.h
index 76e4d3128ad4ea3f0601cb5055280a4dc097adc2..8d5e81cc45dc001290ee0a1666ed36d2eee2f2ca 100644
--- a/kernel/peer.h
+++ b/kernel/peer.h
@@ -1,6 +1,7 @@
 /* SPDX-License-Identifier: GPL-2.0 */
 /*
  * Copyright (C) 2015-2019 Jason A. Donenfeld <Jason@zx2c4.com>. All Rights Reserved.
+ * TCP Support Copyright (c) 2024-2026 Jeff Nathan and Dragos Ruiu. All Rights Reserved.
  */
 
 #ifndef _WG_PEER_H
@@ -14,25 +15,11 @@
 #include <linux/netfilter.h>
 #include <linux/spinlock.h>
 #include <linux/kref.h>
+#include <linux/mutex.h>
 #include <net/dst_cache.h>
 
 struct wg_device;
-
-struct endpoint {
-	union {
-		struct sockaddr addr;
-		struct sockaddr_in addr4;
-		struct sockaddr_in6 addr6;
-	};
-	union {
-		struct {
-			struct in_addr src4;
-			/* Essentially the same as addr6->scope_id */
-			int src_if4;
-		};
-		struct in6_addr src6;
-	};
-};
+struct wg_socket_data;
 
 struct wg_peer {
 	struct wg_device *device;
@@ -41,7 +28,7 @@ struct wg_peer {
 	int serial_work_cpu;
 	bool is_dead;
 	struct noise_keypairs keypairs;
-	struct endpoint endpoint;
+	struct endpoint endpoint, tcp_reply_endpoint, peer_endpoint;
 	struct dst_cache endpoint_cache;
 	rwlock_t endpoint_lock;
 	struct noise_handshake handshake;
@@ -64,6 +51,76 @@ struct wg_peer {
 	struct list_head allowedips_list;
 	struct napi_struct napi;
 	u64 internal_id;
+	u64 tcp_connection_id; /* Nonzero only for a provisional accepted stream. */
+
+	/* TCP-related members */
+	bool peer_endpoint_set;
+	__be16 tcp_peer_listen_port; /* Configured, never an accepted source port. */
+	struct socket *peer_socket, *inbound_socket, *outbound_socket;
+	struct wg_socket_data *tcp_outbound_socket_data;
+	struct wg_socket_data *tcp_inbound_socket_data;
+	/* True while the corresponding socket callbacks are installed. */
+	bool tcp_outbound_callbacks_set;
+	bool tcp_inbound_callbacks_set;
+	ktime_t outbound_timestamp, inbound_timestamp; /* timestamps for connections */
+	struct sockaddr_storage	inbound_source, outbound_source, inbound_dest, outbound_dest;
+
+	struct sk_buff *partial_skb;
+	size_t expected_len;
+	size_t received_len;
+
+	struct delayed_work tcp_retry_work; /* Work for retrying TCP connection */
+	bool tcp_retry_scheduled; /* Flag to track connect retry scheduling */
+
+	/* Removes the outbound peer TCP connection. */
+	struct delayed_work tcp_outbound_remove_work;
+	bool tcp_outbound_remove_scheduled; /* Flag to track outbound peer removal scheduling */
+	bool tcp_reconnect_requested; /* Reconnect after the current outbound socket is quiesced */
+	bool tcp_stopping; /* Device/peer stop owns all TCP work cancellation */
+	bool tcp_teardown_quarantined; /* Retains callback-reachable state on invariant failure */
+	struct socket *tcp_outbound_remove_socket; /* Exact socket claimed by the removal owner */
+	u64 tcp_roaming_connection_id; /* Newest authenticated accepted carrier */
+	/* Removes the inbound peer TCP connection. */
+	struct delayed_work tcp_inbound_remove_work;
+	bool tcp_inbound_remove_scheduled; /* Flag to track inbound peer removal scheduling */
+	struct socket *tcp_inbound_remove_socket; /* Exact socket claimed by the removal owner */
+
+	/* Removes TCP connections from the pending list. */
+	struct delayed_work tcp_cleanup_work;
+	bool tcp_cleanup_scheduled; /* Flag to track removal scheduling */
+
+	bool tcp_established; /* Flag to track TCP connection status */
+	bool tcp_pending; /* Flag to track outbount pending TCP connection status */
+	bool tcp_connecting; /* Synchronous connect setup owns outbound cleanup */
+	bool inbound_connected; /* peer connected to us */
+	bool outbound_connected; /* we connected to them */
+	bool clean_outbound; /* release outbound at next cleanup */
+	bool clean_inbound; /* release inbound at next cleanup */
+	bool temp_peer; /* is this a temporary peer */
+
+
+	struct sk_buff_head send_queue; /* TX queue */
+        spinlock_t send_queue_lock; /* TX lock */
+
+	struct list_head pending_connection_list; /* peers pending connection handshake */
+	struct mutex tcp_socket_lock; /* Serializes socket publication and callback ownership */
+	spinlock_t tcp_lock; /* Protects TCP-related state */
+
+	struct work_struct tcp_read_work; /* Work struct for scheduling the worker */
+	struct workqueue_struct *tcp_read_wq; /* Workqueue for handling TCP data processing */
+	spinlock_t tcp_read_lock; /* Spinlock to protect access to the socket data */
+	bool tcp_read_worker_scheduled; /* Flag to indicate if the TCP read worker is scheduled */
+
+	struct work_struct tcp_write_work; /* Work struct for scheduling the worker */
+	struct workqueue_struct *tcp_write_wq; /* Workqueue for handling TCP data processing */
+	spinlock_t tcp_write_lock; /* Spinlock to protect access to the socket data */
+	bool tcp_write_worker_scheduled; /* Flag to indicate if the TCP write worker is scheduled */
+	struct work_struct tcp_bootstrap_work;
+	struct socket *tcp_bootstrap_socket;
+	struct work_struct tcp_promotion_work;
+	u64 tcp_promotion_connection_id;
+	bool tcp_promotion_worker_scheduled;
+
 };
 
 struct wg_peer *wg_peer_create(struct wg_device *wg,
@@ -76,6 +133,7 @@ static inline struct wg_peer *wg_peer_get(struct wg_peer *peer)
 	kref_get(&peer->refcount);
 	return peer;
 }
+
 void wg_peer_put(struct wg_peer *peer);
 void wg_peer_remove(struct wg_peer *peer);
 void wg_peer_remove_all(struct wg_device *wg);
diff --git a/kernel/queueing.h b/kernel/queueing.h
index 1ea4f874e367ee4185efd0cce9f2358c0d3d5e01..5b2493fe94f08ac1d36085a28a39db38f9895093 100644
--- a/kernel/queueing.h
+++ b/kernel/queueing.h
@@ -11,7 +11,9 @@
 #include <linux/skbuff.h>
 #include <linux/ip.h>
 #include <linux/ipv6.h>
+#include <linux/wireguard.h>
 #include <net/ip_tunnels.h>
+#include "wg_tcp_debug.h"
 
 struct wg_device;
 struct wg_peer;
@@ -58,10 +60,14 @@ enum packet_state {
 
 struct packet_cb {
 	u64 nonce;
+	u64 tcp_connection_id;
 	struct noise_keypair *keypair;
 	atomic_t state;
 	u32 mtu;
+	__be16 frag_id;
+	__be16 frag_off;
 	u8 ds;
+	u8 outer_ipproto;
 };
 
 #define PACKET_CB(skb) ((struct packet_cb *)((skb)->cb))
@@ -75,6 +81,7 @@ static inline bool wg_check_packet_protocol(struct sk_buff *skb)
 
 static inline void wg_reset_packet(struct sk_buff *skb, bool encapsulating)
 {
+	wg_dbg("Entering wg_reset_packet\n");
 	u8 l4_hash = skb->l4_hash;
 	u8 sw_hash = skb->sw_hash;
 	u32 hash = skb->hash;
@@ -100,6 +107,8 @@ static inline void wg_reset_packet(struct sk_buff *skb, bool encapsulating)
 	skb_reset_transport_header(skb);
 	skb_probe_transport_header(skb);
 	skb_reset_inner_headers(skb);
+
+	wg_dbg("Exiting wg_reset_packet\n");
 }
 
 static inline int wg_cpumask_choose_online(int *stored_cpu, unsigned int id)
@@ -159,7 +168,7 @@ static inline int wg_queue_enqueue_per_device_and_peer(
 	struct sk_buff *skb, struct workqueue_struct *wq)
 {
 	int cpu;
-
+	wg_dbg("Entering wg_queue_enqueue_per_device_and_peer \n");
 	atomic_set_release(&PACKET_CB(skb)->state, PACKET_STATE_UNCRYPTED);
 	/* We first queue this up for the peer ingestion, but the consumer
 	 * will wait for the state to change to CRYPTED or DEAD before.
@@ -174,11 +183,13 @@ static inline int wg_queue_enqueue_per_device_and_peer(
 	if (unlikely(ptr_ring_produce_bh(&device_queue->ring, skb)))
 		return -EPIPE;
 	queue_work_on(cpu, wq, &per_cpu_ptr(device_queue->worker, cpu)->work);
+	wg_dbg("Exiting wg_queue_enqueue_per_device_and_peer \n");
 	return 0;
 }
 
 static inline void wg_queue_enqueue_per_peer_tx(struct sk_buff *skb, enum packet_state state)
 {
+	wg_dbg("Entering wg_queue_enqueue_per_peer_tx \n");
 	/* We take a reference, because as soon as we call atomic_set, the
 	 * peer can be freed from below us.
 	 */
@@ -188,10 +199,12 @@ static inline void wg_queue_enqueue_per_peer_tx(struct sk_buff *skb, enum packet
 	queue_work_on(wg_cpumask_choose_online(&peer->serial_work_cpu, peer->internal_id),
 		      peer->device->packet_crypt_wq, &peer->transmit_packet_work);
 	wg_peer_put(peer);
+	wg_dbg("Exiting wg_queue_enqueue_per_peer_tx\n");
 }
 
 static inline void wg_queue_enqueue_per_peer_rx(struct sk_buff *skb, enum packet_state state)
 {
+	wg_dbg("Entering wg_queue_enqueue_per_peer_rx \n");
 	/* We take a reference, because as soon as we call atomic_set, the
 	 * peer can be freed from below us.
 	 */
@@ -200,6 +213,7 @@ static inline void wg_queue_enqueue_per_peer_rx(struct sk_buff *skb, enum packet
 	atomic_set_release(&PACKET_CB(skb)->state, state);
 	napi_schedule(&peer->napi);
 	wg_peer_put(peer);
+	wg_dbg("Exiting wg_queue_enqueue_per_peer_rx\n");
 }
 
 #ifdef DEBUG
